// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

/* Generated by Together */

// Auxiliary class to cover behavior what was 
// covered by an innerclass before.

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

import com.togethersoft.openapi.ide.command.IdeCommandAdapter;
import com.togethersoft.openapi.ide.command.IdeCommandEvent;
import com.togethersoft.openapi.ide.window.IdeWindowManager;
import com.togethersoft.openapi.ide.IdeContext;
import com.togethersoft.openapi.ide.diagram.IdeDiagramManagerAccess;

import com.togethersoft.openapi.rwi.RwiElement;
import com.togethersoft.openapi.rwi.RwiDiagram;
import com.togethersoft.openapi.rwi.RwiModelAccess;
import com.togethersoft.openapi.rwi.RwiModel;


import java.net.*;

import de.uka.ilkd.key.casetool.together.keydebugclassloader.KeyDebugClassLoader;

public class OpMenuIdeAdapter extends IdeCommandAdapter{

    public OpMenuIdeAdapter(KeyMenuExtension script, IdeWindowManager aWinMan, int ind1,  String className) {
	lnkKeyMenuExtension = script;
	winMan = aWinMan;
        groupElementNo = ind1;
	opMenuRootCN = className;
    }

   private int groupElementNo;
    private String opMenuRootCN;
    private IdeWindowManager winMan;
    private KeyMenuExtension lnkKeyMenuExtension;



    public void checkStatus(IdeCommandEvent event) {
	try{
	    lnkKeyMenuExtension.myOpItem[groupElementNo-1].setText(((OpMenu) Class.forName(opMenuRootCN + "Point" + groupElementNo).newInstance()).getMenuEntry());
	}catch(Exception e){
	    System.err.println("KeYError: " + e);
	    e.printStackTrace();
	}
	lnkKeyMenuExtension.myOpItem[groupElementNo-1].setEnabled(true);
	lnkKeyMenuExtension.myOpItem[groupElementNo-1].setVisible(true);
    }

    public void actionPerformed(IdeCommandEvent event) { 
	// what should be done be selecting this context menu
	IdeContext context = event.getElementContext(); //getting the element(s) under the cursor
	RwiDiagram activeRwiDiagram = IdeDiagramManagerAccess.getDiagramManager().getActiveDiagram().getRwiDiagram();
	RwiModel currentRwiModel = RwiModelAccess.getModel();

	Class cl;
	ClassLoader classLoader = this.getClass().getClassLoader();
	if ("on".equals(System.getProperty("KeyDebugClassLoader"))){
	    // installing the keydebugclassloader instead
	    // see also de.uka.ilkd.tjext.keydebugclassloader.KeyScript
	    try{
		classLoader = new KeyDebugClassLoader(classLoader);
		((KeyDebugClassLoader) classLoader).setClassAlwaysAskParent(OpMenu.class);
	    }catch(Exception e){
		System.err.println("KeYError: " + e);
		e.printStackTrace();
	    }
	}
	try{
	    cl = classLoader.loadClass(opMenuRootCN + "Point" + groupElementNo);
	    // now creating an instance of the (re)loaded class and 
	    // invoking the run-method
 	    OpMenu instance = (OpMenu) cl.newInstance();
 	    instance.run(winMan, context, currentRwiModel, activeRwiDiagram);
	}catch(Throwable e){
	    System.err.println("KeYError: " + e);
	    e.printStackTrace();
	}

    }



}

