// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.gui;

import java.awt.Font;
import java.awt.Color;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import de.uka.ilkd.key.util.Debug;
import de.uka.ilkd.key.proof.Node;

public class NonGoalInfoView extends JTextArea {
    
    public NonGoalInfoView (Node node, KeYMediator mediator) {
	SequentPrinter printer = new SequentPrinter
	    (new ProgramPrinter(null), 
	     mediator.getNotationInfo(),
	     node.sequent());
	node.sequent().prettyprint(printer);
	String s = printer.toString();
	s = s + "\n \nUpcoming rule application: \n";
	s = s + node.getAppliedRuleApp().rule();	

	Config.DEFAULT.addConfigChangeListener(
	    new ConfigChangeListener() {
		    public void configChanged(ConfigChangeEvent e) {
			updateUI();
		    }
		});

	updateUI();
	setText(s);
	setEditable(false);
    }


    public void updateUI() {
	super.updateUI();
	Font myFont = UIManager.getFont(Config.KEY_FONT_INNER_NODE_VIEW);
	if (myFont != null) {
	    setFont(myFont);
	} else {
	    Debug.out("KEY-INNER_NODE_FONT not available, use standard font.");
	}
    }

}
