// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.java;

import recoder.java.declaration.*;
import recoder.list.*;

/** this class stores recoder related contextinformation used to parse
 * in program parts in which non-declared variables are used
 */
class Context {

    private recoder.java.CompilationUnit compilationUnitContext;
    private ClassDeclaration classContext;
    
    /** creates a new context object
     * @param compilationUnitContext a
     * recoder.java.CompilationUnit
     * @param classContext a recoder.java.declaration.ClassDeclaration
     */
    public Context(recoder.java.CompilationUnit compilationUnitContext, 
		   ClassDeclaration classContext) {
	this.compilationUnitContext = compilationUnitContext;
	this.classContext = classContext;
    }

    /** creates a new context object
     * @param compilationUnitContext a
     * recoder.java.declaration.CompilationUnit
     */
    public Context(recoder.java.CompilationUnit compilationUnitContext) {
	this(compilationUnitContext, 
	     new ClassDeclaration());
    }
    
    /** creates a new context object
     * @param classContext a recoder.java.declaration.ClassDeclaration
     */
    public Context(ClassDeclaration classContext) {
	this(new recoder.java.CompilationUnit(null, null, inList(classContext)),
	     classContext);
    }

    /** creates the empty context */
    public Context() {
	this(
	     //new recoder.java.CompilationUnit(), 
	     new ClassDeclaration());
    }

    public static TypeDeclarationMutableList inList(TypeDeclaration td) {
	TypeDeclarationMutableList tdml=new TypeDeclarationArrayList();
	tdml.add(td);
	return tdml;
    }

    /** returns the compilation context */
    public recoder.java.CompilationUnit getCompilationUnitContext() {
	return compilationUnitContext;
    }

    /** returns the compilation context */
    public ClassDeclaration getClassContext() {
	return classContext;
    }

    
}
