// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//


package de.uka.ilkd.key.logic;

import de.uka.ilkd.key.gui.SequentPrinter;
import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.logic.QuantifierTerm;
import de.uka.ilkd.key.logic.ldt.*;
import de.uka.ilkd.key.logic.op.ArrayOfQuantifiableVariable;
/**
 * Axiom inherits from Term. It represents an axiom in an abstract
 * data type. It consists of a conjunction of equalities and
 * inequalities, which are implicitly quantified.
 */

public class Axiom extends Term { //@@@ this class is not yet designed
    
    QuantifierTerm term;
    /** depth of the term */
    private final int depth;
    
    public Axiom(QuantifierTerm t){//@@@
	super(t.op());
	term = t;
	depth = t.depth() + 1;
    } 

    public Axiom(Term t){
	super(t.op());
	if (t instanceof QuantifierTerm) { term = (QuantifierTerm)t; }
	else { System.out.println( "This is wrong this should not happen u stupid!"); }
	depth = t.depth() + 1;
    }

    public int arity(){//@@@
	return 0;
    }

    /**@return depth of the term */
    public int depth() {
	return depth;
    }


    public Term sub(int i){//@@@
	return this;
    }

    public ArrayOfQuantifiableVariable varsBoundHere(int i){//@@@
	//alle variablen sind hier quantifiziert.
	return null;
    }


}

