// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//


package de.uka.ilkd.key.logic.op;

import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.gui.SequentPrinter;
import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.Term;
public class Metavariable extends TermSymbol {
    
    public Metavariable(Name name,Sort sort) {
	this.name=name;
	this.sort=sort;	
    }


    /** @return true iff number of subterms of term is 0
     */
    public boolean validTopLevel(Term term){
        return term.arity()==0;
    }

    public String toString() {
	return name+":"+sort;
    }

   /** @return arity of the Metavariable as int */
    public int arity() {
	return 0;
    }
}
