// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001 Universitaet Karlsruhe, Germany
//                    and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General 
// Public License. See LICENSE.TXT for details.
//

package de.uka.ilkd.key.logic.sort;

import de.uka.ilkd.key.logic.Name;
public class ObjectSort extends de.uka.ilkd.key.logic.sort.AbstractNonCollectionSort {

    public static final SetOfSort EMPTY_SORT_SET=SetAsListOfSort.EMPTY_SET;

    SetOfSort ext;

    /** creates an ObjectSort*/
    public ObjectSort(Name name, SetOfSort ext) {
	super(name);
	this.ext=ext;
    }

    /** creates an ObjectSort*/
    public ObjectSort(Name name, de.uka.ilkd.key.logic.sort.Sort ext) {
	this(name, SetAsListOfSort.EMPTY_SET.add(ext));
    }


    /** creates an ObjectSort*/
    public ObjectSort(Name name) {
	this(name, SetAsListOfSort.EMPTY_SET);
    }

   
    /**
     * @return the sorts of the predecessors of this sort
     */
    public SetOfSort extendsSorts() {
	return ext;
    }

}
